Boomkinator = LibStub("AceAddon-3.0"):NewAddon("Boomkinator", "AceConsole-3.0", "AceEvent-3.0", "AceTimer-3.0")

local L    = LibStub("AceLocale-3.0"):GetLocale("Boomkinator")

-- localize functions
local UnitGUID = _G.UnitGUID
local UnitExists = _G.UnitExists
local UnitBuff = _G.UnitBuff
local UnitDebuff = _G.UnitDebuff
local UnitClass = _G.UnitClass
local UnitPower = _G.UnitPower
local GetSpellInfo = _G.GetSpellInfo
local GetSpellCooldown = _G.GetSpellCooldown
local GetSpellTexture = _G.GetSpellTexture
local sformat = string.format

--
local settings
local updater = ""

local spells = {}
local icons = {}
local buttons = {}
local timers = {}
local stacks = {}

local wreak = false
local implode = false
local blaze = false
local burn = false
local immolateTable = {}

Boomkinator.Credits1 = "Boomkinator - by Aznamir (Lightbringer US)";

-------------------------------------------------------------------
-- Spell Settings
-------------------------------------------------------------------
Boomkinator.OwlSpells = {
	[1] = 8921,		-- Moonfire
	[2] = 93402,	-- Sunfire
	[3] = 194153,	-- Lunar Strike
	[4] = 5176,		-- Solar Wrath
	[5] = 78674,	-- Starsurge
	[6] = 191034,	-- Starfall
	[7] = 202767,	-- Artifact (New Moon)
	[12]= 164547,	-- lunar empowerment
	[13]= 164545,	-- solar empowerment
}
Boomkinator.CombatSpells = {
	[1] = 1766, 	-- kick
	[2] = 13877, 	-- blade flurry
	[3] = 13750,	-- #8 adrenaline rush,
	[4] = 195627,  	--opportunity
	[5] = 212198,   --crimson-vial
	[6] = 199804,	--between-the-eyes
	[7] = 193316, 	-- roll the bones
	[9] = 202665,   -- curse of dreadblades
	[11]= 193359, 	-- true-bearing
	[12]= 193357, 	-- shark-infested-waters
	[13]= 199603, 	-- jolly-roger
	[14]= 193358, 	-- grand-melee
	[15]= 193356, 	-- broadsides
	[16]= 199600, 	-- buried-treasure
	}
Boomkinator.AffSpells = {
	[1] = 980,		-- agony
	[2] = 172, 		-- corruption
	[3] = 63106, 	-- siphon life
	[4] = 689, 		-- drain life
	[5] = 30108, 	-- unstable affliction
	[6] = 48181, 	-- haunt
	[7] = 18540, 	-- doomguard
	[8] = 111897, 	-- grimoire: felhunter
	[9] = 216695,	-- tormented souls,
	[10]= 199440,	-- deadwind hardvester
}
Boomkinator.DestSpells = {
	[1] = 348,		-- immolate
	[2] = 17877,	-- shadow burn
	[3] = 116858,	-- chaos bolt
	[4] = 29722,	-- incinerate
	[5] = 17962,	-- conflagrate
	[6] = 80240,	-- havoc	
	[7] = 18540, 	-- doomguard
	[8] = 111859, 	-- grimoire: imp
	[9] = 196586, 	-- artifact dimensional rift
	[10]= 196414,  	-- eradication	
}
Boomkinator.DemoSpells = {
	[1] = 603, 		-- doom
	[2] = 104316, 	-- call dreadstalkers
	[3] = 119898, 	-- command demon
	[4] = 196657,	-- shadow bolt
	[5] = 105174,	-- HoG
	[6] = 193396, 	-- demonic empowerment
	[7] = 196277, 	-- implosion
	[8] = 211717, 	-- artifact
	[9] = 18540, 	-- doomguard
	[10]= 111898,	-- grimoire: felguard
	[11]= 205145,	-- demonic calling
	[12]= 188857, 	-- demon-rush
}
-------------------------------------------------------------------
-- Interface settings
-------------------------------------------------------------------
Boomkinator.options =
{
	type = "group",
	name = "Boomkinator",
	args = {
		desc = {
			type = "description",
			order = 0,
			name = L["MOVE_DESC"],
		},
		reset = {
			type = "execute",
			order = 1,
			name = L["RESET"],
			desc = L["RESET_DESC"],
			func = function() Boomkinator:Reset() end,
		},
		show = {
			type = "execute",
			order = 2,
			name = L["SHOW"],
			desc = L["SHOW_DESC"],
			func = function() Boomkinator:ShowLayout() end,
		},
		hide = {
			type = "execute",
			order = 3,
			name = L["HIDE"],
			desc = L["HIDE_DESC"],
			func = function() Boomkinator:HideLayout() end,
		},
		lock = {
			type = "execute",
			order = 4,
			name = L["LOCK"],
			desc = L["LOCK_DESC"],
			func = function() 
					settings.locked = true
					Boomkinator:LockLayout() 
				end,
		},
		unlock = {
			type = "execute",
			order = 5,
			name = L["UNLOCK"],
			desc = L["UNLOCK_DESC"],
			func = function()
					settings.locked = false
					Boomkinator:UnlockLayout()
				end,
		},
		scale = {
			type = "range",
			order = 6,
			name = L["BSC"],
			desc = L["BSC_DESC"],
			min = 0.4,
			max = 1.5,
			step = 0.05,
			get = function(info) return settings.buffscale end,
			set = function(info, val)
					settings.buffscale = val
					Boomkinator:UpdateLayout()
				end,
		},
		fontscale = {
			type = "range",
			order = 7,
			name = "Font Scale",
			desc = "Scale of timer fonts", 
			min = 8,
			max = 14,
			step = 1,
			get = function(info) return settings.fontscale end,
			set = function(info, val)
					settings.fontscale = val
					Boomkinator:UpdateLayout()
				end,
		},
		rows = {
			type = "range",
			order = 8,
			name = "Display Rows",
			desc = "Number of button rows", 
			min = 1,
			max = 3,
			step = 1,
			get = function(info) return settings.rows end,
			set = function(info, val)
					settings.rows = val
					Boomkinator:UpdateLayout()
				end,
		},
	},
}
-------------------------------------------------------------------
-- Default Settings
-------------------------------------------------------------------
Boomkinator.defaults = {
	profile = {
		buffscale = 0.9,
		fontscale = 10,
		locked = false,
		disabled = false,
		rows = 3
	}
}
-------------------------------------------------------------------
-- Ace Framework Events
-------------------------------------------------------------------
function Boomkinator:OnInitialize()
	--self:Print("OnInitialize")
	DEFAULT_CHAT_FRAME:AddMessage("|cff33ff99"..Boomkinator.Credits1.."|r")
	self.db = LibStub("AceDB-3.0"):New("BoomkinatorDB", Boomkinator.defaults, "Default")
	self.db.RegisterCallback(self, "OnProfileChanged", "OnProfileChanged")
	self.db.RegisterCallback(self, "OnProfileCopied", "OnProfileChanged")
	self.db.RegisterCallback(self, "OnProfileReset", "OnProfileChanged")
	settings = self.db.profile
	Boomkinator.options.args.profiles = LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db)

	LibStub("AceConfig-3.0"):RegisterOptionsTable("Boomkinator", Boomkinator.options, "boom")
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("Boomkinator", "Boomkinator")

	self:UpdateLayout()
end

function Boomkinator:OnProfileChanged()
	--self:Print("OnProfileChanged")
	settings = self.db.profile
	self:UpdateLayout()
end

function Boomkinator:OnEnable()
	--self:Print("OnEnable")
	settings.disabled = false
	self:RegisterEvent("PLAYER_REGEN_ENABLED")
	self:RegisterEvent("PLAYER_REGEN_DISABLED")
	--self:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")
	self:RegisterEvent("PLAYER_TALENT_UPDATE")
	self:RegisterEvent("ENCOUNTER_START")
	self:RegisterEvent("ENCOUNTER_END")
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	self:UpdateLayout()
end

function Boomkinator:OnDisable()
	--self:Print("OnDisable")
	-- events
	settings.disabled = true
	self:UpdateLayout()
end

function Boomkinator:MediaUpdate()

end
-------------------------------------------------------------------
-- Service Functions
-------------------------------------------------------------------
function Boomkinator:FormatTime(time)
	if not time or time < 0 or time == 9999 then
		return ""
	end
	local mins = floor(time / 60)
	local secs = time - (mins * 60)
	return sformat("%d:%02d", mins, secs)
end

function Boomkinator:FormatShort(time)
	if not time or time < 0 or time == 9999 then
		return ""
	end
	return sformat("%0.1f", time)
end

function Boomkinator:ReadableNumber(num, places)
    local ret
    local placeValue = ("%%.%df"):format(places or 0)
    if not num then
        return 0
    elseif num >= 1000000000000 then
        ret = placeValue:format(num / 1000000000000) .. " T" -- trillion
    elseif num >= 1000000000 then
        ret = placeValue:format(num / 1000000000) .. " B" -- billion
    elseif num >= 1000000 then
        ret = placeValue:format(num / 1000000) .. " M" -- million
    elseif num >= 1000 then
        ret = placeValue:format(num / 1000) .. "K" -- thousand
    else
        ret = num -- hundreds
    end
    return ret
end
-------------------------------------------------------------------
-- Command Prompt Response
-------------------------------------------------------------------
function Boomkinator:Reset()
	local h = _G["BoomkinatorFrame"]
	h:ClearAllPoints()
	h:SetPoint("CENTER", "UIParent", "CENTER", 0, 0)
	--self:UpdateLayout()
end

function Boomkinator:Debug()
	self:Print("Spells:")
	for i = 1, 16 do
		self:Print("  " .. i .. " = " .. (spells[i] or ""))
	end
	self:Print("Icons:")
	for i = 1, 16 do
		self:Print("  " .. i .. " = " .. (icons[i] or ""))
	end

end

-------------------------------------------------------------------
-- Internal Functions
-------------------------------------------------------------------

-------------------------------------------------------------------
-- External Event Handling
------------------------------------------------------------------
function Boomkinator:PLAYER_REGEN_ENABLED()
	--self:Print("Regen Enabled")
	self:CancelTimer(self.UpdateTimer, true)
	self:HideLayout()
end

function Boomkinator:PLAYER_REGEN_DISABLED()
	--self:Print("Regen Disabled")

	if updater == "" then
		--self:Print("Entered combat without settings, trying to fix UI")
		self:UpdateLayout()
	end
	
	if updater ~= "" then
		--self:Print(updater)
		self.UpdateTimer = self:ScheduleRepeatingTimer(updater, 0.1)
		self:ShowLayout()
	end
end

function Boomkinator:ACTIVE_TALENT_GROUP_CHANGED()
	self:UpdateLayout()
end

function Boomkinator:PLAYER_TALENT_UPDATE()
	self:UpdateLayout()
end

function Boomkinator:ENCOUNTER_START()
	immolateTable = {}
end

function Boomkinator:ENCOUNTER_END()
	immolateTable = {}
end

function Boomkinator:COMBAT_LOG_EVENT_UNFILTERED(event, ...)
	local sourceGUID = select(4, ...)
	if sourceGUID == UnitGUID("player") and updater == "ButtonsDestructUpdate" then
		local SAR = "SPELL_AURA_REMOVED"
        local SAA = "SPELL_AURA_APPLIED"
        local SARe = "SPELL_AURA_REFRESH"
        local SD = "SPELL_DAMAGE"
        local ImmolateCastID = 348
        local ImmolateDoTID = 157736
        local ConflagID = 17962
		--local destGUID = select(8, ...)
        --local subevent = select(2, ...)
        --local spellid = select(12, ...)
		
		local _, subevent, _, _, _, _, _, destGUID, _, _, _, spellid = ...
		if spellid == ImmolateDoTID and (subevent == SAA or subevent == SARe) then
			immolateTable[destGUID] = 1
		elseif spellid == ImmolateDoTID and  subevent == SAR then
			immolateTable[destGUID] = nil
		elseif spellid == ConflagID and subevent == SD then
            if immolateTable[destGUID] ~= nil then
                immolateTable[destGUID] = immolateTable[destGUID] * 1.6
            end
		end
	end
end
-------------------------------------------------------------------
-- Internal Functions
-------------------------------------------------------------------

function Boomkinator:CheckTalents()
	local _, class = UnitClass("player")
	-- druid
	if class == "DRUID" and GetSpecialization() == 1 then -- moonkin
		updater = "ButtonsOwlUpdate"
	-- rogue
	elseif class == "ROGUE" and  GetSpecialization() == 2 then -- rogue combat
		updater = "ButtonsCombatUpdate"
	-- warlock
	elseif class == "WARLOCK" and GetSpecialization() == 1 then -- affliction
		updater = "ButtonsAfflictionUpdate"
	elseif class == "WARLOCK" and GetSpecialization() == 2 then -- demonology
		updater = "ButtonsDemonologyUpdate"
	elseif class == "WARLOCK" and GetSpecialization() == 3 then -- destruction
		updater = "ButtonsDestructUpdate"		
	else
		updater = ""
	end
end
-------------------------------------------------------------------
-- Buff UI Setup
-------------------------------------------------------------------
function Boomkinator:UpdateLayout()
	--self:Print("Update Layout")
	local spellName, spellIcon, spellSelected, spellID
	
	self:CheckTalents()
	if updater == "ButtonsOwlUpdate" then
		spells = Boomkinator.OwlSpells
		icons = {
			[1] = select(3, GetSpellInfo(spells[1])),  	-- (button 1)	moonfire 		
			[2] = nil, 									-- (button 2)	dynamic
			[3] = select(3, GetSpellInfo(spells[2])),	-- (button 3)	sunfire 			
			[4] = select(3, GetSpellInfo(spells[3])), 	-- (button 4)	lunar strike 	
			[5] = select(3, GetSpellInfo(spells[5])), 	-- (button 5)	starsurge 
			[6] = select(3, GetSpellInfo(spells[4])), 	-- (button 6)   solar wrath
			[7] = select(3, GetSpellInfo(spells[6])), 	-- (button 7)	starfall
			[8] = nil,									-- (button 8) 	dynamic
			[9] = select(3, GetSpellInfo(spells[7])), 	-- (button 9) 	artifact
			[10] = nil,									-- empty
		}
		-- talent customizations
		-- alignments vs incarnation
		spellSelected = select(4, GetTalentInfo(5, 2, 1))
		if spellSelected then
			spells[8] = 102560 -- incarnation
			icons[8] = select(3, GetSpellInfo(spells[8]))
		else
			spells[8] = 194223 -- alignment
			icons[8] = select(3, GetSpellInfo(spells[8]))
		end
		-- flare
		spellSelected = select(4,  GetTalentInfo(5, 3, 1))
		if spellSelected then
			spells[9] = 202347
			icons[2] = select(3, GetSpellInfo(spells[9]))
		else
			spells[9] = nil
			icons[2] = nil
		end
	elseif updater == "ButtonsCombatUpdate" then
		spells = Boomkinator.CombatSpells
		icons = {
			[1] = select(3, GetSpellInfo(spells[1])),
			[2] = select(3, GetSpellInfo(spells[2])),
			[3] = select(3, GetSpellInfo(spells[3])),
			[4] = select(3, GetSpellInfo(spells[4])),
			[5] = select(3, GetSpellInfo(spells[5])),
			[6] = select(3, GetSpellInfo(spells[6])),
			[7] = select(3, GetSpellInfo(spells[7])),
			[8] = nil,									-- dynamic
			[9] = select(3, GetSpellInfo(spells[9])),
			[10]= nil,									-- empty
			[11]= select(3, GetSpellInfo(spells[11])),	-- bones
			[12]= select(3, GetSpellInfo(spells[12])),
			[13]= select(3, GetSpellInfo(spells[13])),
			[14]= select(3, GetSpellInfo(spells[14])),
			[15]= select(3, GetSpellInfo(spells[15])),
			[16]= select(3, GetSpellInfo(spells[16])),
		}	
	elseif updater == "ButtonsAfflictionUpdate" then
		spells = Boomkinator.AffSpells
		icons = {
			[1] = select(3, GetSpellInfo(spells[1])),
			[2] = select(3, GetSpellInfo(spells[2])),
			[3] = select(3, GetSpellInfo(spells[3])),
			[4] = select(3, GetSpellInfo(spells[4])),
			[5] = select(3, GetSpellInfo(spells[5])),
			[6] = nil,
			[7] = select(3, GetSpellInfo(spells[7])),
			[8] = select(3, GetSpellInfo(spells[8])),
			[9] = select(3, GetSpellInfo(spells[9])),
			[10] = nil,
		}
		-- haunt check
		spellSelected = select(4, GetTalentInfo(1, 1, 1))
		if spellSelected then
			icons[6] = select(3, GetSpellInfo(spells[6]))
		else
			spells[6] = nil
			icons[6] = nil
		end
	elseif updater == "ButtonsDemonologyUpdate" then
		spells = Boomkinator.DemoSpells
		icons = {
			[1] = select(3, GetSpellInfo(spells[1])),
			[2] = select(3, GetSpellInfo(spells[2])),
			[3] = select(3, GetSpellInfo(spells[3])),
			[4] = select(3, GetSpellInfo(spells[4])),
			[5] = select(3, GetSpellInfo(spells[5])),
			[6] = select(3, GetSpellInfo(spells[6])),
			[7] = select(3, GetSpellInfo(spells[7])),
			[8] = select(3, GetSpellInfo(spells[8])),
			[9] = select(3, GetSpellInfo(spells[9])),
			[10]=  select(3, GetSpellInfo(spells[10])),
		}
		-- implosion
		implode = select(4, GetTalentInfo(2, 3, 1))
		if not implode then
			icons[7] = nil
		end
	elseif updater == "ButtonsDestructUpdate" then
		spells = Boomkinator.DestSpells
		icons = {
			[1] = select(3, GetSpellInfo(spells[1])),
			[2] = select(3, GetSpellInfo(spells[2])),
			[3] = select(3, GetSpellInfo(spells[3])),
			[4] = select(3, GetSpellInfo(spells[4])),
			[5] = select(3, GetSpellInfo(spells[5])),
			[6] = select(3, GetSpellInfo(spells[6])),
			[7] = select(3, GetSpellInfo(spells[7])),
			[8] = select(3, GetSpellInfo(spells[8])),
			[9] = select(3, GetSpellInfo(spells[9])),
			[10]= nil,
		}
		-- roaring blaze
		blaze = select(4, GetTalentInfo(1, 2, 1))
		-- shadow burn
		burn = select(4, GetTalentInfo(1, 3, 1))
		if not burn then
			icons[2] = nil
		end
		-- wreak havoc
		wreak = select(4, GetTalentInfo(7, 1, 1))
	else
		icons = {}
	end
	
	if updater ~= nil then
		bframe = _G["BoomkinatorFrame"]

		for i = 1, 10 do
			buttons[i] = _G["BoomkinatorFrameButton"..i]
			buttons[i]:SetTexture(icons[i])
			buttons[i]:SetVertexColor(1, 1, 1, 1)
			timers[i]  = _G["BoomkinatorFrameTime"..i]
			timers[i]:SetText("")
			timers[i]:SetFont("Fonts\\FRIZQT__.TTF", settings.fontscale)
			stacks[i]  = _G["BoomkinatorFrameStack"..i]
			stacks[i]:SetText("")
			stacks[i]:SetFont("Fonts\\FRIZQT__.TTF", settings.fontscale)
		end
	end
	if settings.rows == 1 then
		buttons[2]:SetPoint("TOPLEFT", buttons[1], "TOPRIGHT", 2, 0)
		buttons[3]:SetPoint("TOPLEFT", buttons[2], "TOPRIGHT", 2, 0)
		buttons[4]:SetPoint("TOPLEFT", buttons[3], "TOPRIGHT", 2, 0)
		buttons[5]:SetPoint("TOPLEFT", buttons[4], "TOPRIGHT", 2, 0)
		buttons[6]:SetPoint("TOPLEFT", buttons[5], "TOPRIGHT", 2, 0)
		buttons[7]:SetPoint("TOPLEFT", buttons[6], "TOPRIGHT", 2, 0)
		buttons[8]:SetPoint("TOPLEFT", buttons[7], "TOPRIGHT", 2, 0)
		buttons[9]:SetPoint("TOPLEFT", buttons[8], "TOPRIGHT", 2, 0)
		buttons[10]:SetPoint("TOPLEFT", buttons[9], "TOPRIGHT", 2, 0)
	elseif settings.rows == 2 then
		buttons[2]:SetPoint("TOPLEFT", buttons[1], "TOPRIGHT", 2, 0)
		buttons[3]:SetPoint("TOPLEFT", buttons[2], "TOPRIGHT", 2, 0)
		buttons[4]:SetPoint("TOPLEFT", buttons[3], "TOPRIGHT", 2, 0)
		buttons[5]:SetPoint("TOPLEFT", buttons[4], "TOPRIGHT", 2, 0)
		buttons[6]:SetPoint("TOPLEFT", buttons[1], "BOTTOMLEFT", 0, -1)
		buttons[7]:SetPoint("TOPLEFT", buttons[6], "TOPRIGHT", 2, 0)
		buttons[8]:SetPoint("TOPLEFT", buttons[7], "TOPRIGHT", 2, 0)
		buttons[9]:SetPoint("TOPLEFT", buttons[8], "TOPRIGHT", 2, 0)
		buttons[10]:SetPoint("TOPLEFT", buttons[9], "TOPRIGHT", 2, 0)
	else
		buttons[2]:SetPoint("TOPLEFT", buttons[1], "TOPRIGHT", 2, 0)
		buttons[3]:SetPoint("TOPLEFT", buttons[2], "TOPRIGHT", 2, 0)
		buttons[4]:SetPoint("TOPLEFT", buttons[1], "BOTTOMLEFT", 0, -1)
		buttons[5]:SetPoint("TOPLEFT", buttons[4], "TOPRIGHT", 2, 0)
		buttons[6]:SetPoint("TOPLEFT", buttons[5], "TOPRIGHT", 2, 0)
		buttons[7]:SetPoint("TOPLEFT", buttons[4], "BOTTOMLEFT", 0, -1)
		buttons[8]:SetPoint("TOPLEFT", buttons[7], "TOPRIGHT", 2, 0)
		buttons[9]:SetPoint("TOPLEFT", buttons[8], "TOPRIGHT", 2, 0)
		buttons[10]:SetPoint("TOPLEFT", buttons[9], "TOPRIGHT", 2, 0)
	end
	
	BoomkinatorFrame:SetScale(settings.buffscale)
	self:HideLayout()

	if settings.locked then
		Boomkinator:LockLayout()
	else
		Boomkinator:UnlockLayout()
	end
end

function Boomkinator:ShowLayout()
	bframe:Show()
end

function Boomkinator:HideLayout()
	bframe:Hide()
end

function Boomkinator:LockLayout()
	bframe:EnableMouse(false)
end

function Boomkinator:UnlockLayout()
	bframe:EnableMouse(true)
end

function Boomkinator:GetSeverityColor(percent)
	if (percent >= 0.5) then
		return (1.0-percent)*2, 1.0, 0.0
	else
		return 1.0, percent*2, 0.0
	end
end

-------------------------------------------------------------------
-- Class Functionality: Warlock Affliction
-------------------------------------------------------------------
function Boomkinator:ButtonsAfflictionUpdate()
    local expire
	local spellName, spellIcon
	local shards
		
	shards = UnitPower("player" , 7)  -- SPELL_POWER_SOUL_SHARDS 
	
	if UnitExists("target") then
		--check agony
		spellName = GetSpellInfo(spells[1])
		_, _, spellIcon, _, _, buffDuration, buffExpire = UnitDebuff("target", spellName, nil, "PLAYER")
		
		if buffExpire then
			expire = buffExpire - GetTime()
			timers[1]:SetText(Boomkinator:FormatShort(expire))
			buttons[1]:SetVertexColor(1, 1, 1, 0.5)
		else
			timers[1]:SetText("")
			buttons[1]:SetVertexColor(1, 1, 1, 1)
		end			

		--check corruption
		spellName = GetSpellInfo(spells[2])
		_, _, spellIcon, _, _, buffDuration, buffExpire = UnitDebuff("target", spellName, nil, "PLAYER")
		
		if buffExpire then
			expire = buffExpire - GetTime()
			timers[2]:SetText(Boomkinator:FormatShort(expire))
			buttons[2]:SetVertexColor(1, 1, 1, 0.5)
		else
			timers[2]:SetText("")
			buttons[2]:SetVertexColor(1, 1, 1, 1)
		end			
		
		-- siphon
		spellName = GetSpellInfo(spells[3])
		_, _, spellIcon, _, _, buffDuration, buffExpire = UnitDebuff("target", spellName, nil, "PLAYER")
		
		if buffExpire then
			expire = buffExpire - GetTime()
			timers[3]:SetText(Boomkinator:FormatShort(expire))
			buttons[3]:SetVertexColor(1, 1, 1, 0.5)
		else
			timers[3]:SetText("")
			buttons[3]:SetVertexColor(1, 1, 1, 1)
		end	
		
		--check affliction
			
		if shards == 0 then
			stacks[5]:SetText("")
			buttons[5]:SetVertexColor(1, 1, 1, 1)	
		else
			stacks[5]:SetText("x"..shards)
			buttons[5]:SetVertexColor(1, 1, 1, 1)	
		end
		
		spellName = GetSpellInfo(spells[5])
		_, _, spellIcon, _, _, buffDuration, buffExpire = UnitDebuff("target", spellName, nil, "PLAYER")
		
		if buffExpire then
			expire = buffExpire - GetTime()
			timers[5]:SetText(Boomkinator:FormatShort(expire))
			buttons[5]:SetVertexColor(1, 1, 1, 0.3)
		else
			timers[5]:SetText("")
			if shards > 0 then
				buttons[5]:SetVertexColor(1, 1, 1, 1)
			else
				buttons[5]:SetVertexColor(1, 1, 1, 0.5)
			end
		end
		
		if shards > 0 then
			stacks[5]:SetText("x"..shards)
		else
			stacks[5]:SetText("")
		end
		
		--check haunt
		spellName = GetSpellInfo(spells[6])
		if spellName then
			_, _, spellIcon, _, _, buffDuration, buffExpire = UnitDebuff("target", spellName, nil, "PLAYER")
			
			if buffExpire then
				expire = buffExpire - GetTime()
				timers[6]:SetText(Boomkinator:FormatShort(expire))
				buttons[6]:SetVertexColor(1, 1, 1, 0.5)
			else
				timers[6]:SetText("")
				buttons[6]:SetVertexColor(1, 1, 1, 1)
			end	
		end
	end
	
	local start, duration

	-- doomguard
	spellName = GetSpellInfo(spells[7])
	start, duration = GetSpellCooldown(spellName)
	if start then
		if start == 0 or (start > 0 and duration < 1.5 ) then
			timers[7]:SetText("")
			buttons[7]:SetVertexColor(1, 1, 1, 1)
		else
			-- on cooldown
			expire = start + duration - GetTime()
			timers[7]:SetText(Boomkinator:FormatTime(expire))
			buttons[7]:SetVertexColor(1, 1, 1, 0.5)
		end
	else
		timers[7]:SetText("NA")
		buttons[7]:SetVertexColor(1, 1, 1, 0.3)
	end
	
	-- grimoire
	spellName = GetSpellInfo(spells[8])
	start, duration = GetSpellCooldown(spellName)
	if start then
		if start == 0 or (start > 0 and duration < 1.5 ) then
			timers[8]:SetText("")
			buttons[8]:SetVertexColor(1, 1, 1, 1)
		else
			-- on cooldown
			expire = start + duration - GetTime()
			timers[8]:SetText(Boomkinator:FormatTime(expire))
			buttons[8]:SetVertexColor(1, 1, 1, 0.5)
		end
	else
		timers[8]:SetText("NA")
		buttons[8]:SetVertexColor(1, 1, 1, 0.3)
	end
			
	-- artifact
	-- collected souls
	spellName = GetSpellInfo(spells[9])
	buffCount = select(4, UnitBuff("player", spellName))
	if buffCount then
		stacks[9]:SetText("x" .. buffCount)
	else
		stacks[9]:SetText("")
	end
	-- timer
	spellName = GetSpellInfo(spells[10])
	buffName, _, _, _, _, buffDuration, buffExpire = UnitBuff("player", spellName)
	if buffName and buffExpire then
		expire = buffExpire - GetTime()
		timers[9]:SetText(Boomkinator:FormatShort(expire))
		buttons[9]:SetVertexColor(1, 1, 1, 0.5)
	else
		timers[9]:SetText("")
		buttons[9]:SetVertexColor(1, 1, 1, 0.75)
	end

end
-------------------------------------------------------------------
-- Class Functionality: Warlock Demonology
-------------------------------------------------------------------
function Boomkinator:ButtonsDemonologyUpdate()
    local expire
	local spellName, spellIcon
	local shards
	-- regular cooldowns
	local start, duration
	local buffName, buffDuration, buffExpire, buffCount
	
	if  zpetsplayerguid then -- zpets installed and active
		if zpetspetsneedde > 0 then
			stacks[6]:SetText("x"..zpetspetsneedde)
			stacks[6]:SetTextColor(1, 0.2, 0.2, 1)
			buttons[6]:SetVertexColor(1, 1, 1, 0.75)
		else
			stacks[6]:SetText("")
			buttons[6]:SetVertexColor(1, 1, 1, 0.25)
		end
		
		if UnitExists("pet") then
		-- check demonic empowerment
			spellName = GetSpellInfo(spells[6])
			buffName, _, _, _, _, buffDuration, buffExpire = UnitBuff("pet", spellName)
		
			if buffExpire then
				expire = buffExpire - GetTime()
				timers[6]:SetText(Boomkinator:FormatShort(expire))
			else
				timers[6]:SetText("")
			end	
		end
		
		-- pet and implosion count
		if implode then 
			stacks[7]:SetText("x" .. zpetsdreadcount + zpetstotalimpcount)
			timers[7]:SetText(Boomkinator:ReadableNumber(zpetstotalvalueofimplosion))
			if zpetstotalvalueofimplosion > 100000 then
				buttons[7]:SetVertexColor(1, 1, 1, 0.50)
				timers[7]:SetTextColor(0.4, 1, 0, 1)
			else
				buttons[7]:SetVertexColor(1, 1, 1, 0.25)
				timers[7]:SetTextColor(0.2, 1, 1, 1)
			end
		end
		-- consumption count
		stacks[8]:SetText(Boomkinator:ReadableNumber(zpetsthalkielstotalvalue))
	else
		if UnitExists("pet") then
		-- check demonic empowerment
			spellName = GetSpellInfo(spells[6])
			buffName, _, _, _, _, buffDuration, buffExpire = UnitBuff("pet", spellName)
			if buffExpire then
				expire = buffExpire - GetTime()
				timers[3]:SetText(Boomkinator:FormatShort(expire))
				buttons[3]:SetVertexColor(1, 1, 1, 0.25)
			else
				timers[3]:SetText("")
				buttons[3]:SetVertexColor(1, 1, 1, 0.75)
			end	
		end
	end
		
	shards = UnitPower("player" , 7)  -- SPELL_POWER_SOUL_SHARDS 
	stacks[5]:SetText("x"..shards)
	if shards >= 3 then
		buttons[5]:SetVertexColor(1, 1, 1, 0.75)
	elseif shards >= 2 then
		buttons[5]:SetVertexColor(1, 1, 1, 0.5)
	else
		buttons[5]:SetVertexColor(1, 1, 1, 0.25)	
	end
	
	if UnitExists("target") then
		--check doom
		spellName = GetSpellInfo(spells[1])
		_, _, spellIcon, _, _, buffDuration, buffExpire = UnitDebuff("target", spellName, nil, "PLAYER")
		
		if buffExpire then
			expire = buffExpire - GetTime()
			timers[1]:SetText(Boomkinator:FormatShort(expire))
			buttons[1]:SetVertexColor(1, 1, 1, 0.25)
		else
			timers[1]:SetText("")
			buttons[1]:SetVertexColor(1, 1, 1, 0.75)
		end			
	end
	
	-- demon rush
	spellName = GetSpellInfo(spells[12])
	buffName, _, _, buffCount, _, buffDuration, buffExpire = UnitBuff("player", spellName)
	
	if buffName and buffExpire then
		stacks[4]:SetText("x" .. buffCount)
		stacks[4]:SetTextColor(Boomkinator:GetSeverityColor(buffCount/10))
		buttons[4]:SetVertexColor(1, 1, 1, 0.50)
	else
		stacks[4]:SetText("")
		buttons[4]:SetVertexColor(1, 1, 1, 0.75)
	end
	
	local start, duration
		
	-- demonic calling
	spellName = GetSpellInfo(spells[10])
	buffName, _, _, _, _, _, _ = UnitBuff("player", spellName)
	-- call dreadstalkers	
	if shards >= 2 or buffName then
		spellName = Boomkinator.DemoSpells[2]
		start, duration = GetSpellCooldown(spellName)
		if start then
			if start == 0 or (start > 0 and duration < 1.5 ) then
				timers[2]:SetText("")
				buttons[2]:SetVertexColor(1, 1, 1, 0.75)
			else
				-- on cooldown
				expire = start + duration - GetTime()
				timers[2]:SetText(Boomkinator:FormatTime(expire))
				buttons[2]:SetVertexColor(1, 1, 1, 0.25)
			end
		else
			timers[2]:SetText("NA")
			buttons[2]:SetVertexColor(1, 1, 1, 0.25)	
		end
	else
		timers[2]:SetText("")
		buttons[2]:SetVertexColor(1, 1, 1, 0.25)
	end

	-- artifact
	spellName = GetSpellInfo(spells[8])
	start, duration = GetSpellCooldown(spellName)
	if start then
		if start == 0 or (start > 0 and duration < 1.5 ) then
			timers[8]:SetText("")
			buttons[8]:SetVertexColor(1, 1, 1, 0.75)
		else
			-- on cooldown
			expire = start + duration - GetTime()
			timers[8]:SetText(Boomkinator:FormatTime(expire))
			buttons[8]:SetVertexColor(1, 1, 1, 0.25)
		end
	else
		timers[8]:SetText("NA")
		buttons[8]:SetVertexColor(1, 1, 1, 0.25)
	end
	
	-- custom pet actions
	spellName = GetSpellInfo(spells[3])
	spellIcon = select(3, GetSpellInfo(spells[3]))
	buttons[3]:SetTexture(spellIcon)
	start, duration = GetSpellCooldown(spellName)
	if start then
		if start == 0 or (start > 0 and duration < 1.5 ) then
			timers[3]:SetText("")
			buttons[3]:SetVertexColor(1, 1, 1, 0.75)
		else
			-- on cooldown
			expire = start + duration - GetTime()
			timers[3]:SetText(Boomkinator:FormatTime(expire))
			buttons[3]:SetVertexColor(1, 1, 1, 0.25)
		end
	else
		timers[3]:SetText("NA")
		buttons[3]:SetVertexColor(1, 1, 1, 0.25)
	end
	
	-- doomguard
	spellName = GetSpellInfo(spells[9])
	start, duration = GetSpellCooldown(spellName)
	if start then
		if start == 0 or (start > 0 and duration < 1.5 ) then
			timers[9]:SetText("")
			buttons[9]:SetVertexColor(1, 1, 1, 0.75)
		else
			-- on cooldown
			expire = start + duration - GetTime()
			timers[9]:SetText(Boomkinator:FormatTime(expire))
			buttons[9]:SetVertexColor(1, 1, 1, 0.25)
		end
	else
		timers[9]:SetText("NA")
		buttons[9]:SetVertexColor(1, 1, 1, 0.25)
	end

	-- grimoire
	spellName = GetSpellInfo(spells[10])
	start, duration = GetSpellCooldown(spellName)
	if start then
		if start == 0 or (start > 0 and duration < 1.5 ) then
			timers[10]:SetText("")
			buttons[10]:SetVertexColor(1, 1, 1, 1)
		else
			-- on cooldown
			expire = start + duration - GetTime()
			timers[10]:SetText(Boomkinator:FormatTime(expire))
			buttons[10]:SetVertexColor(1, 1, 1, 0.5)
		end
	else
		timers[10]:SetText("NA")
		buttons[10]:SetVertexColor(1, 1, 1, 0.3)
	end
end
-------------------------------------------------------------------
-- Class Functionality: Warlock Destruction
-------------------------------------------------------------------
function Boomkinator:ButtonsDestructUpdate()
    local expire
	local spellName, spellIcon
	local shards
	local guid
	-- regular cooldowns
	local start, duration

	shards = UnitPower("player" , 7)  -- SPELL_POWER_SOUL_SHARDS 
	
	stacks[4]:SetText("x"..shards)
	
	if shards < 2 then
		buttons[4]:SetVertexColor(1, 1, 1, 0.75)
	elseif shards < 4 then
		buttons[4]:SetVertexColor(1, 1, 1, 0.5)
	else
		buttons[4]:SetVertexColor(1, 1, 1, 0.25)	
	end

	if UnitExists("target") then
		--check immolate
		spellName = GetSpellInfo(spells[1])
		_, _, spellIcon, _, _, buffDuration, buffExpire = UnitDebuff("target", spellName, nil, "PLAYER")
		
		if buffExpire then
			expire = buffExpire - GetTime()
			timers[1]:SetText(Boomkinator:FormatShort(expire))
			buttons[1]:SetVertexColor(1, 1, 1, 0.25)
		else
			timers[1]:SetText("")
			buttons[1]:SetVertexColor(1, 1, 1, 0.75)
		end			

		if blaze then
			guid = UnitGUID("target")
			if immolateTable[guid] ~= nil then
				stacks[1]:SetText("x"..sformat("%0.1f", immolateTable[guid]))
			else
				stacks[1]:SetText("")
			end
		end
		
		-- check eradicate
		spellName = GetSpellInfo(spells[10])
		_, _, spellIcon, _, _, buffDuration, buffExpire = UnitDebuff("target", spellName, nil, "PLAYER")
		
		if buffExpire then
			expire = buffExpire - GetTime()
			timers[3]:SetText(Boomkinator:FormatShort(expire))
		else
			timers[3]:SetText("")
		end
		
		-- shadowburn
		if UnitHealth("target")/UnitHealthMax("target") < 0.2 and shards >= 1  and burn then
			buttons[2]:SetVertexColor(1, 1, 1, 0.75)
		else
			-- hold shadowburn
			buttons[2]:SetVertexColor(1, 1, 1, 0.25)
		end
		
		-- conflag
		spellName = GetSpellInfo(spells[5])
		buffCount, _, _, _ = GetSpellCharges(spellName)
		stacks[5]:SetText("x" .. buffCount)
		if buffCount == 2 and shards < 4 then
			buttons[5]:SetVertexColor(1, 1, 1, 0.75)
		elseif buffCount == 1 and shards < 5 then
			buttons[5]:SetVertexColor(1, 1, 1, 0.5)			
		else
			buttons[5]:SetVertexColor(1, 1, 1, 0.25)
		end
		
		-- rift
		spellName = GetSpellInfo(spells[9])
		buffCount, _, _, _ = GetSpellCharges(spellName)
				
		if buffCount and buffCount > 0 then
			stacks[9]:SetText("x" .. buffCount)
			timers[9]:SetText("")
		else
			stacks[9]:SetText("")
		end
		
		if buffCount == 3 then
			buttons[9]:SetVertexColor(1, 1, 1, 1)
		elseif buffCount == 2 then
			buttons[9]:SetVertexColor(1, 1, 1, 0.75)			
		elseif buffCount == 1 then			
			buttons[9]:SetVertexColor(1, 1, 1, 0.50)
		else
			buttons[9]:SetVertexColor(1, 1, 1, 0.25)
			
		--check cooldown for next
			start, duration = GetSpellCooldown(spellName)
			if start then
				if start == 0 or (start > 0 and duration < 1.5 ) then
					timers[9]:SetText("")
				else
					expire = start + duration - GetTime()
					timers[9]:SetText(Boomkinator:FormatTime(expire))
				end
			end
		end
		
		-- chaos bolt
		if shards >= 2 then
			buttons[3]:SetVertexColor(1, 1, 1, 1)
		else
			buttons[3]:SetVertexColor(1, 1, 1, 0.3)
		end
	end
		
	-- Havoc
	if not wreak then -- on cooldown
		spellName = GetSpellInfo(spells[6])
		start, duration = GetSpellCooldown(spellName)
		if start then
			if start == 0 or (start > 0 and duration < 1.5 ) then
				timers[6]:SetText("")
				buttons[6]:SetVertexColor(1, 1, 1, 1)
			else
				-- on cooldown
				expire = start + duration - GetTime()
				timers[6]:SetText(Boomkinator:FormatTime(expire))
				buttons[6]:SetVertexColor(1, 1, 1, 0.5)
			end
		else
			timers[6]:SetText("NA")
			buttons[6]:SetVertexColor(1, 1, 1, 0.3)
		end
	else
		-- debuff on focus
		if UnitExists("focus") then
			spellName = GetSpellInfo(spells[6])
			_, _, spellIcon, _, _, buffDuration, buffExpire = UnitDebuff("focus", spellName, nil, "PLAYER")
		
			if buffExpire then
				expire = buffExpire - GetTime()
				timers[6]:SetText(Boomkinator:FormatShort(expire))
				buttons[6]:SetVertexColor(1, 1, 1, 0.25)
			else
				timers[6]:SetText("")
				buttons[6]:SetVertexColor(1, 1, 1, 0.75)
			end			
		end
	end
		
	-- doomguard
	spellName = GetSpellInfo(spells[7])
	start, duration = GetSpellCooldown(spellName)
	if start then
		if start == 0 or (start > 0 and duration < 1.5 ) then
			timers[7]:SetText("")
			buttons[7]:SetVertexColor(1, 1, 1, 1)
		else
			-- on cooldown
			expire = start + duration - GetTime()
			timers[7]:SetText(Boomkinator:FormatTime(expire))
			buttons[7]:SetVertexColor(1, 1, 1, 0.5)
		end
	else
		timers[7]:SetText("NA")
		buttons[7]:SetVertexColor(1, 1, 1, 0.3)
	end
	
	-- grimoire
	spellName = GetSpellInfo(spells[8])
	start, duration = GetSpellCooldown(spellName)
	if start then
		if start == 0 or (start > 0 and duration < 1.5 ) then
			timers[8]:SetText("")
			buttons[8]:SetVertexColor(1, 1, 1, 1)
		else
			-- on cooldown
			expire = start + duration - GetTime()
			timers[8]:SetText(Boomkinator:FormatTime(expire))
			buttons[8]:SetVertexColor(1, 1, 1, 0.5)
		end
	else
		timers[8]:SetText("NA")
		buttons[8]:SetVertexColor(1, 1, 1, 0.3)
	end
	
end
-------------------------------------------------------------------
-- Class Functionality: Rogue Combat
-------------------------------------------------------------------
function Boomkinator:ButtonsCombatUpdate()
    local expire
	local spellName, spellIcon
	local combos
	local start, duration
	local dice = 0
	local tb = 0
	
	combos = UnitPower("player", 4) -- combo points
	if combos > 0 then
		stacks[7]:SetText("x" .. combos)
	else
		stacks[7]:SetText("")
	end
	buttons[7]:SetVertexColor(1, 1, 1, 0.5)
	-- bone analysis
	for i = 1, 6 do
		spellName = GetSpellInfo(spells[i+10])
		buffName, _, _, _, _, _, buffExpire = UnitBuff("player", spellName)
		if buffName and buffExpire then
			expire = buffExpire - GetTime()
			dice = dice + 1
			if i == 1 then tb = 1 end
			if dice == 1 then
				buttons[8]:SetTexture(icons[i+10])
				buttons[8]:SetVertexColor(1, 1, 1, 0.5)
				timers[8]:SetText(Boomkinator:FormatTime(expire))
			end
		end
	end
	if dice == 0 then
		buttons[8]:SetTexture(nil)
		timers[8]:SetText("")
	else
		if dice > 1 then
			stacks[8]:SetText("+" .. ( dice - 1) )
			stacks[8]:SetTextColor(0,1,1,1)
		else
			stacks[8]:SetText("")
		end
	end
		
	-- kick
	spellName = GetSpellInfo(spells[1])
	start, duration = GetSpellCooldown(spellName)
	if start then
		if start == 0 or (start > 0 and duration < 1.5 ) then
			timers[1]:SetText("")
			buttons[1]:SetVertexColor(1, 1, 1, 0.75)
		else
			-- on cooldown
			expire = start + duration - GetTime()
			timers[1]:SetText(Boomkinator:FormatTime(expire))
			buttons[1]:SetVertexColor(1, 1, 1, 0.5)
		end
	else
		timers[1]:SetText("NA")
		buttons[1]:SetVertexColor(1, 1, 1, 0.3)
	end
	
	-- blade flurry
	spellName = GetSpellInfo(spells[2])
	buffName, _, _, _, _, buffDuration, buffExpire = UnitBuff("player", spellName)
	
	if buffName and buffExpire then
		expire = buffExpire - GetTime()
		timers[2]:SetText(Boomkinator:FormatShort(expire))
		buttons[2]:SetVertexColor(1, 1, 1, 0.3)
	else
		timers[2]:SetText("")
		buttons[2]:SetVertexColor(1, 1, 1, 0.75)
	end
	
	-- check cooldowns
	-- rush
	spellName = GetSpellInfo(spells[3])
	start, duration = GetSpellCooldown(spellName)
	if start then
		if (start == 0 or (start > 0 and duration < 1.5 )) and tb == 1 then
			timers[3]:SetText("")
			buttons[3]:SetVertexColor(1, 1, 1, 0.75)
		else
			-- on cooldown
			expire = start + duration - GetTime()
			timers[3]:SetText(Boomkinator:FormatTime(expire))
			buttons[3]:SetVertexColor(1, 1, 1, 0.3)
		end
	else
		timers[3]:SetText("NA")
		buttons[3]:SetVertexColor(1, 1, 1, 0.3)
	end
	
	-- opportiunity
	spellName = GetSpellInfo(spells[4])
	buffName, _, _, _, _, buffDuration, buffExpire = UnitBuff("player", spellName)
	
	if buffName and buffExpire then
		expire = buffExpire - GetTime()
		timers[4]:SetText(Boomkinator:FormatShort(expire))
		buttons[4]:SetVertexColor(1, 1, 1, 0.75)
	else
		timers[4]:SetText("")
		buttons[4]:SetVertexColor(1, 1, 1, 0.3)
	end
	
	-- vial
	spellName = GetSpellInfo(spells[5])
	start, duration = GetSpellCooldown(spellName)
	if start then
		if start == 0 or (start > 0 and duration < 1.5 ) then
			timers[5]:SetText("")
			buttons[5]:SetVertexColor(1, 1, 1, 0.75)
		else
			-- on cooldown
			expire = start + duration - GetTime()
			timers[5]:SetText(Boomkinator:FormatTime(expire))
			buttons[5]:SetVertexColor(1, 1, 1, 0.5)
		end
	else
		timers[5]:SetText("NA")
		buttons[5]:SetVertexColor(1, 1, 1, 0.3)
	end
	
	-- shot
	spellName = GetSpellInfo(spells[6])
	start, duration = GetSpellCooldown(spellName)
	if start then
		if start == 0 or (start > 0 and duration < 1.5 ) then
			timers[6]:SetText("")
			buttons[6]:SetVertexColor(1, 1, 1, 0.75)
		else
			-- on cooldown
			expire = start + duration - GetTime()
			timers[6]:SetText(Boomkinator:FormatTime(expire))
			buttons[6]:SetVertexColor(1, 1, 1, 0.5)
		end
	else
		timers[6]:SetText("NA")
		buttons[6]:SetVertexColor(1, 1, 1, 0.3)
	end
	
	-- blades
	spellName = GetSpellInfo(spells[9])
	start, duration = GetSpellCooldown(spellName)
	if start then
		if start == 0 or (start > 0 and duration < 1.5 ) then
			timers[9]:SetText("")
			buttons[9]:SetVertexColor(1, 1, 1, 0.75)
		else
			-- on cooldown
			expire = start + duration - GetTime()
			timers[9]:SetText(Boomkinator:FormatTime(expire))
			buttons[9]:SetVertexColor(1, 1, 1, 0.5)
		end
	else
		timers[9]:SetText("NA")
		buttons[9]:SetVertexColor(1, 1, 1, 0.3)
	end
	
end
-------------------------------------------------------------------
-- Class Functionality: Druid Moonkin
-------------------------------------------------------------------
function Boomkinator:ButtonsOwlUpdate()
	local spellName, spellIcon
	local buffName, buffDuration, buffExpire, buffCount
	local start, duration, expire
	
	local power = UnitPower("player", SPELL_POWER_ECLIPSE)
		
	if power > 0 then -- solar
		stacks[5]:SetText(power)
	else
		stacks[5]:SetText("")
	end
	
	-- starfall
	if power >= 60 then
		buttons[7]:SetVertexColor(1, 1, 1, 0.75)
	else
		buttons[7]:SetVertexColor(1, 1, 1, 0.25)
	end
	
	-- starsurge
	if power >= 40 then
		buttons[5]:SetVertexColor(1, 1, 1, 0.75)
	else
		buttons[5]:SetVertexColor(1, 1, 1, 0.25)
	end
	
	-- lunar empowerment
	spellName = GetSpellInfo(spells[12])
	buffName, _, _, _, _, buffDuration, buffExpire = UnitBuff("player", spellName)
	if buffName then
		stacks[4]:SetText("X")
		buttons[4]:SetVertexColor(1, 1, 1, 1)
	else
		stacks[4]:SetText("")
		buttons[4]:SetVertexColor(1, 1, 1, 0.5)
	end

	-- solar empowerment
	spellName = GetSpellInfo(spells[13])
	buffName, _, _, _, _, buffDuration, buffExpire = UnitBuff("player", spellName)
	if buffName then
		stacks[6]:SetText("X")
		buttons[6]:SetVertexColor(1, 1, 1, 1)
	else
		stacks[6]:SetText("")
		buttons[6]:SetVertexColor(1, 1, 1, 0.5)
	end

	-- new moon
	spellName = GetSpellInfo(spells[7])
	-- dynamic icon
	spellIcon = GetSpellTexture(spellName)
	buttons[9]:SetTexture(spellIcon)
	-- charges
	buffCount, _, _, _ = GetSpellCharges(spellName)
	if buffCount and buffCount > 0 then
        stacks[9]:SetText("x" .. buffCount)
        timers[9]:SetText("")
	end
	if buffCount and buffCount > 0 then
		buttons[9]:SetVertexColor(1, 1, 1, 0.75)
	else
        buttons[9]:SetVertexColor(1, 1, 1, 0.25)

		--check cooldown for next
        start, duration = GetSpellCooldown(spellName)
        if start then
			if start == 0 or (start > 0 and duration < 1.5 ) then
				timers[9]:SetText("")
            else
				expire = start + duration - GetTime()
                timers[9]:SetText(Boomkinator:FormatTime(expire))
            end
        end
	end

	if UnitExists("target") then
		-- checking for debuffs on the target
		-- moonfire
		spellName = GetSpellInfo(spells[1])
		_, _, _, _, _, buffDuration, buffExpire = UnitDebuff("target", spellName, nil, "PLAYER")
		if buffExpire then
			expire = buffExpire - GetTime()
			timers[1]:SetText(Boomkinator:FormatShort(expire))
			buttons[1]:SetVertexColor(1, 1, 1, 0.25)
		else
			timers[1]:SetText("")
			buttons[1]:SetVertexColor(1, 1, 1, 1)
		end
		-- sunfire
		spellName = GetSpellInfo(spells[2])
		_, _, _, _, _, buffDuration, buffExpire = UnitDebuff("target", spellName, nil, "PLAYER")
		if buffExpire then
			expire = buffExpire - GetTime()
			timers[3]:SetText(Boomkinator:FormatShort(expire))
			buttons[3]:SetVertexColor(1, 1, 1, 0.25)
		else
			timers[3]:SetText("")
			buttons[3]:SetVertexColor(1, 1, 1, 1)
		end
		--spellflare
		spellName = GetSpellInfo(spells[9])
		if spellName then
			_, _, _, _, _, buffDuration, buffExpire = UnitDebuff("target", spellName, nil, "PLAYER")
			if buffExpire then
				expire = buffExpire - GetTime()
				timers[2]:SetText(Boomkinator:FormatShort(expire))
				buttons[2]:SetVertexColor(1, 1, 1, 0.25)
			elseif power >= 15 then
				timers[2]:SetText("")
				buttons[2]:SetVertexColor(1, 1, 1, 1)
			else
				timers[2]:SetText("")
				buttons[2]:SetVertexColor(1, 1, 1, 0.25)
			end
		else
			timers[2]:SetText("NA")
			buttons[2]:SetVertexColor(1, 1, 1, 0.25)
		end
	end
	
	-- alignment
	spellName = GetSpellInfo(spells[8])
	start, duration = GetSpellCooldown(spellName)
	if start then
		if start == 0 or (start > 0 and duration < 1.5 ) then
			timers[8]:SetText("")
			buttons[8]:SetVertexColor(1, 1, 1, 0.75)
		else
			-- on cooldown
			expire = start + duration - GetTime()
			timers[8]:SetText(Boomkinator:FormatTime(expire))
			buttons[8]:SetVertexColor(1, 1, 1, 0.25)
		end
	else
		timers[8]:SetText("NA")
		buttons[8]:SetVertexColor(1, 1, 1, 0.25)
	end
end